#pragma once
#include <vector>
#include "TrilinearGridContribution.h" 

class RotationMatrix ; 
namespace CryoData
{
	class ProjectionData ; 
}


class RBFGridModel
{
	std::vector<RotationMatrix> mvectRotations ;

	unsigned char mbyteGridSide ; 
	unsigned char mbyteImageSide ; 
	float mfltRadius ; // standard deviation of gaussians.
	float mfltMaxDist ; //maximum distribution for contributions.

	bool mblnUseRandomRotations ; 
public:
	int GetNumRotations() { return mvectRotations.size() ; } 
	RBFGridModel(
		const std::vector<RotationMatrix> &vectRotMatrices,
		unsigned char gridSide, 
		unsigned char imageSide);
	RBFGridModel(char *fileName) ; 
	RBFGridModel(unsigned char gridSide, unsigned char imageSide) ; 
	~RBFGridModel(void);

	void SetRotations(const std::vector<RotationMatrix> &vectRotMatrices) ;
	void GetGridContributions(
		const unsigned int rotMatrixIndex, 
		std::vector<TrilinearGridContribution> &vectGridContributions,
		const RotationMatrix *randRotMultiplier = NULL) ; 

};
