//	This file is part of CryoBayes.
//  CryoBayes is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  CryoBayes is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// CryoBayes: Copyright 2009,2010 Navdeep Jaitly
#pragma once
#include <vector>
#include "TrilinearGridContribution.h" 
#include "RotationMatrix.h" 
namespace CryoData
{
	class ProjectionData ; 
}


class TrilinearGridModel
{
	std::vector<RotationMatrix> mvectRotations ;

	unsigned char mbyteGridSide ; 
	unsigned char mbyteImageSide ; 

	bool mblnUseRandomRotations ; 
public:
	int GetNumRotations() { return mvectRotations.size() ; } 
	TrilinearGridModel(
		const std::vector<RotationMatrix> &vectRotMatrices,
		unsigned char gridSide, 
		unsigned char imageSide);
	TrilinearGridModel(char *fileName) ; 
	TrilinearGridModel(unsigned char gridSide, unsigned char imageSide) ; 
	~TrilinearGridModel(void);

	RotationMatrix GetRotationMatrix(int index) const 
	{
		return mvectRotations[index] ; 
	}
	void SetRotations(const std::vector<RotationMatrix> &vectRotMatrices) ;
	void GetGridContributions(
		const unsigned int rotMatrixIndex, 
		std::vector<TrilinearGridContribution> &vectGridContributions) ; 

};
